import tasks from './tasks';


console.info('Crypto worker registered');

function selectTask(taskName) {
  switch (taskName) {
    case 'factorize':
      return tasks.factorize;
    case 'mod-pow':
      return tasks.modPow;
    case 'sha1-hash':
      return tasks.sha1Hash;
    case 'aes-encrypt':
      return tasks.aesEncrypt;
    case 'aes-decrypt':
      return tasks.aesDecrypt;
    default:
      throw new Error(`Unknown task: ${taskName}`);
  }
}

function runTask(ctx) {
  var { task, taskID, data } = ctx;
  var fn = selectTask(task);
  var result = fn(data);
  postMessage({ taskID, result }, '*');
}

onmessage = msg => {
  if (typeof msg.data === 'string') {
    if (msg.data === '') console.info('empty crypto task');else console.info('crypto task string message', msg.data);
    return;
  }
  runTask(msg.data);
};

postMessage('ready', '*');
//# sourceMappingURL=worker.js.map