'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.queryAck = exports.queryKeys = exports.querySalt = exports.queryAuthKey = exports.queryAuthID = exports.queryHomeDc = exports.getHomeStatus = exports.queryRequest = exports.resolveRequest = undefined;
exports.getClient = getClient;

var _apropos = require('apropos');

var _maybe = require('folktale/maybe');

var _portal = require('../portal');

require('../index.h');

var _newtype = require('../../newtype.h');

var _keyStorage = require('../../util/key-storage');

var resolveRequest = exports.resolveRequest = (uid, dc, outID) => getClient(uid).map(({ command }) => command).chain(command => command.maybeGetK(outID)).map(pair => pair.snd());

var queryRequest = exports.queryRequest = (uid, dc, outID) => resolveRequest(uid, dc, outID).chain(reqID => getClient(uid).chain(state => state.request.maybeGetK(reqID))).map(pair => pair.snd());

function getClient(uid) {
  return (0, _maybe.fromNullable)(_portal.getState).chain(e => (0, _maybe.fromNullable)(e())).chain(e => (0, _maybe.fromNullable)(e.client)).chain(e => (0, _maybe.fromNullable)(e[uid]));
  // const { client } = getState()
  // return fromNullable(client[uid])
}

var getHomeStatus = exports.getHomeStatus = uid => getClient(uid).map(client => client.homeStatus).fold(() => false, x => x);

var keyQuery = selector => (uid, dc) => getClient(uid).map(selector).chain(_maybe.fromNullable).chain(keyStorage => keyStorage.getMaybe(dc));
/*:: .map(toCryptoKey) */

var queryHomeDc = exports.queryHomeDc = uid => getClient(uid).map(client => client.homeDc).chain(_maybe.fromNullable);
/*:: .map(toDCNumber) */

var queryAuthID = exports.queryAuthID = keyQuery(client => client.authID);
var queryAuthKey = exports.queryAuthKey = keyQuery(client => client.auth);
var querySalt = exports.querySalt = keyQuery(client => client.salt);

var queryKeys = exports.queryKeys = (uid, dc) => (0, _maybe.fromNullable)(dc).chain(dc => queryAuthKey(uid, dc).map(auth => ({ dc, auth }))).chain(({
  dc, auth
}) => queryAuthID(uid, dc).map(authID => ({ dc, auth, authID }))).chain(({
  dc, auth, authID
}) => querySalt(uid, dc).map(salt => ({ uid, dc, auth, authID, salt })));

var queryAck = exports.queryAck = (uid, dc) => (0, _portal.getState)().client[uid].pendingAck[dc] || [];
//# sourceMappingURL=index.js.map